--- pprime_p.c	Tue Jan 16 16:40:44 2007
+++ pprime_p.lut.c	Tue Jan 16 16:40:23 2007
@@ -33,6 +33,28 @@
 static int isprime _PROTO ((unsigned long int t));
 
 
+/* k from t = 2 (k > 16) s.t. p(k, t) <= 2^-80 (8.271806e-25) : */
+
+static const mp_size_t mr_tab[] =
+{
+  0x0a7e, 0x04b0, 0x0314, 0x024e, 0x01db, 0x018f, 0x015a, 0x0133,
+  0x0115, 0x00fd, 0x00e9, 0x00d9, 0x00cc, 0x00c0, 0x00b6, 0x00ae,
+  0x00a7, 0x00a0, 0x009a, 0x0094, 0x008d, 0x0087, 0x0081, 0x007b,
+  0x0075, 0x006e, 0x0068, 0x0062, 0x005c, 0x0055, 0x004f, 0x0049,
+  0x0042, 0x003c, 0x0035, 0x002f, 0x0028, 0x0021, 0x001b, 0x0000
+};
+
+static mp_size_t mr_trials (mp_size_t k)
+{
+  mp_size_t t;
+
+  /* ASSERT(k > 16); */
+
+  for (t = 1; k <= mr_tab[t - 1]; t++);
+  return t;
+}
+
+
 /* MPN_MOD_OR_MODEXACT_1_ODD can be used instead of mpn_mod_1 for the trial
    division.  It gives a result which is not the actual remainder r but a
    value congruent to r*2^n mod d.  Since all the primes being tested are
@@ -134,6 +156,10 @@
   }
 
   /* Perform a number of Miller-Rabin tests.  */
+
+  if (reps == 0)
+    reps = (int) mr_trials(mpz_sizeinbase(n, 2));
+
   return mpz_millerrabin (n, reps);
 }
 
